Code

d63ad2d870423cd28b42993bf35fa0257df654a8
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
6 # if --tee was passed, write the output not only to the terminal, but
7 # additionally to the file test-results/$BASENAME.out, too.
8 case "$GIT_TEST_TEE_STARTED, $* " in
9 done,*)
10         # do not redirect again
11         ;;
12 *' --tee '*|*' --va'*)
13         mkdir -p test-results
14         BASE=test-results/$(basename "$0" .sh)
15         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
16          echo $? > $BASE.exit) | tee $BASE.out
17         test "$(cat $BASE.exit)" = 0
18         exit
19         ;;
20 esac
22 # Keep the original TERM for say_color
23 ORIGINAL_TERM=$TERM
25 # For repeatability, reset the environment to known value.
26 LANG=C
27 LC_ALL=C
28 PAGER=cat
29 TZ=UTC
30 TERM=dumb
31 export LANG LC_ALL PAGER TERM TZ
32 EDITOR=:
33 VISUAL=:
34 unset GIT_EDITOR
35 unset AUTHOR_DATE
36 unset AUTHOR_EMAIL
37 unset AUTHOR_NAME
38 unset COMMIT_AUTHOR_EMAIL
39 unset COMMIT_AUTHOR_NAME
40 unset EMAIL
41 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
42 unset GIT_AUTHOR_DATE
43 GIT_AUTHOR_EMAIL=author@example.com
44 GIT_AUTHOR_NAME='A U Thor'
45 unset GIT_COMMITTER_DATE
46 GIT_COMMITTER_EMAIL=committer@example.com
47 GIT_COMMITTER_NAME='C O Mitter'
48 unset GIT_DIFF_OPTS
49 unset GIT_DIR
50 unset GIT_WORK_TREE
51 unset GIT_EXTERNAL_DIFF
52 unset GIT_INDEX_FILE
53 unset GIT_OBJECT_DIRECTORY
54 unset GIT_CEILING_DIRECTORIES
55 unset SHA1_FILE_DIRECTORIES
56 unset SHA1_FILE_DIRECTORY
57 GIT_MERGE_VERBOSITY=5
58 export GIT_MERGE_VERBOSITY
59 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
60 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
61 export EDITOR VISUAL
62 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
64 # Protect ourselves from common misconfiguration to export
65 # CDPATH into the environment
66 unset CDPATH
68 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
69         1|2|true)
70                 echo "* warning: Some tests will not work if GIT_TRACE" \
71                         "is set as to trace on STDERR ! *"
72                 echo "* warning: Please set GIT_TRACE to something" \
73                         "other than 1, 2 or true ! *"
74                 ;;
75 esac
77 # Each test should start with something like this, after copyright notices:
78 #
79 # test_description='Description of this test...
80 # This test checks if command xyzzy does the right thing...
81 # '
82 # . ./test-lib.sh
83 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
84                 TERM=$ORIGINAL_TERM &&
85                 export TERM &&
86                 [ -t 1 ] &&
87                 tput bold >/dev/null 2>&1 &&
88                 tput setaf 1 >/dev/null 2>&1 &&
89                 tput sgr0 >/dev/null 2>&1
90         ) &&
91         color=t
93 while test "$#" -ne 0
94 do
95         case "$1" in
96         -d|--d|--de|--deb|--debu|--debug)
97                 debug=t; shift ;;
98         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
99                 immediate=t; shift ;;
100         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
101                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
102         -h|--h|--he|--hel|--help)
103                 help=t; shift ;;
104         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
105                 verbose=t; shift ;;
106         -q|--q|--qu|--qui|--quie|--quiet)
107                 quiet=t; shift ;;
108         --no-color)
109                 color=; shift ;;
110         --no-python)
111                 # noop now...
112                 shift ;;
113         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
114                 valgrind=t; verbose=t; shift ;;
115         --tee)
116                 shift ;; # was handled already
117         *)
118                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
119         esac
120 done
122 if test -n "$color"; then
123         say_color () {
124                 (
125                 TERM=$ORIGINAL_TERM
126                 export TERM
127                 case "$1" in
128                         error) tput bold; tput setaf 1;; # bold red
129                         skip)  tput bold; tput setaf 2;; # bold green
130                         pass)  tput setaf 2;;            # green
131                         info)  tput setaf 3;;            # brown
132                         *) test -n "$quiet" && return;;
133                 esac
134                 shift
135                 printf "* %s" "$*"
136                 tput sgr0
137                 echo
138                 )
139         }
140 else
141         say_color() {
142                 test -z "$1" && test -n "$quiet" && return
143                 shift
144                 echo "* $*"
145         }
146 fi
148 error () {
149         say_color error "error: $*"
150         GIT_EXIT_OK=t
151         exit 1
154 say () {
155         say_color info "$*"
158 test "${test_description}" != "" ||
159 error "Test script did not set test_description."
161 if test "$help" = "t"
162 then
163         echo "$test_description"
164         exit 0
165 fi
167 exec 5>&1
168 if test "$verbose" = "t"
169 then
170         exec 4>&2 3>&1
171 else
172         exec 4>/dev/null 3>/dev/null
173 fi
175 test_failure=0
176 test_count=0
177 test_fixed=0
178 test_broken=0
179 test_success=0
181 die () {
182         code=$?
183         if test -n "$GIT_EXIT_OK"
184         then
185                 exit $code
186         else
187                 echo >&5 "FATAL: Unexpected exit with code $code"
188                 exit 1
189         fi
192 GIT_EXIT_OK=
193 trap 'die' EXIT
195 # The semantics of the editor variables are that of invoking
196 # sh -c "$EDITOR \"$@\"" files ...
198 # If our trash directory contains shell metacharacters, they will be
199 # interpreted if we just set $EDITOR directly, so do a little dance with
200 # environment variables to work around this.
202 # In particular, quoting isn't enough, as the path may contain the same quote
203 # that we're using.
204 test_set_editor () {
205         FAKE_EDITOR="$1"
206         export FAKE_EDITOR
207         VISUAL='"$FAKE_EDITOR"'
208         export VISUAL
211 test_decode_color () {
212         sed     -e 's/.\[1m/<WHITE>/g' \
213                 -e 's/.\[31m/<RED>/g' \
214                 -e 's/.\[32m/<GREEN>/g' \
215                 -e 's/.\[33m/<YELLOW>/g' \
216                 -e 's/.\[34m/<BLUE>/g' \
217                 -e 's/.\[35m/<MAGENTA>/g' \
218                 -e 's/.\[36m/<CYAN>/g' \
219                 -e 's/.\[m/<RESET>/g'
222 test_tick () {
223         if test -z "${test_tick+set}"
224         then
225                 test_tick=1112911993
226         else
227                 test_tick=$(($test_tick + 60))
228         fi
229         GIT_COMMITTER_DATE="$test_tick -0700"
230         GIT_AUTHOR_DATE="$test_tick -0700"
231         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
234 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
236 # This will commit a file with the given contents and the given commit
237 # message.  It will also add a tag with <message> as name.
239 # Both <file> and <contents> default to <message>.
241 test_commit () {
242         file=${2:-"$1.t"}
243         echo "${3-$1}" > "$file" &&
244         git add "$file" &&
245         test_tick &&
246         git commit -m "$1" &&
247         git tag "$1"
250 # Call test_merge with the arguments "<message> <commit>", where <commit>
251 # can be a tag pointing to the commit-to-merge.
253 test_merge () {
254         test_tick &&
255         git merge -m "$1" "$2" &&
256         git tag "$1"
259 # This function helps systems where core.filemode=false is set.
260 # Use it instead of plain 'chmod +x' to set or unset the executable bit
261 # of a file in the working directory and add it to the index.
263 test_chmod () {
264         chmod "$@" &&
265         git update-index --add "--chmod=$@"
268 # Use test_set_prereq to tell that a particular prerequisite is available.
269 # The prerequisite can later be checked for in two ways:
271 # - Explicitly using test_have_prereq.
273 # - Implicitly by specifying the prerequisite tag in the calls to
274 #   test_expect_{success,failure,code}.
276 # The single parameter is the prerequisite tag (a simple word, in all
277 # capital letters by convention).
279 test_set_prereq () {
280         satisfied="$satisfied$1 "
282 satisfied=" "
284 test_have_prereq () {
285         case $satisfied in
286         *" $1 "*)
287                 : yes, have it ;;
288         *)
289                 ! : nope ;;
290         esac
293 # You are not expected to call test_ok_ and test_failure_ directly, use
294 # the text_expect_* functions instead.
296 test_ok_ () {
297         test_success=$(($test_success + 1))
298         say_color "" "  ok $test_count: $@"
301 test_failure_ () {
302         test_failure=$(($test_failure + 1))
303         say_color error "FAIL $test_count: $1"
304         shift
305         echo "$@" | sed -e 's/^/        /'
306         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
309 test_known_broken_ok_ () {
310         test_fixed=$(($test_fixed+1))
311         say_color "" "  FIXED $test_count: $@"
314 test_known_broken_failure_ () {
315         test_broken=$(($test_broken+1))
316         say_color skip "  still broken $test_count: $@"
319 test_debug () {
320         test "$debug" = "" || eval "$1"
323 test_run_ () {
324         eval >&3 2>&4 "$1"
325         eval_ret="$?"
326         return 0
329 test_skip () {
330         test_count=$(($test_count+1))
331         to_skip=
332         for skp in $GIT_SKIP_TESTS
333         do
334                 case $this_test.$test_count in
335                 $skp)
336                         to_skip=t
337                 esac
338         done
339         if test -z "$to_skip" && test -n "$prereq" &&
340            ! test_have_prereq "$prereq"
341         then
342                 to_skip=t
343         fi
344         case "$to_skip" in
345         t)
346                 say_color skip >&3 "skipping test: $@"
347                 say_color skip "skip $test_count: $1"
348                 : true
349                 ;;
350         *)
351                 false
352                 ;;
353         esac
356 test_expect_failure () {
357         test "$#" = 3 && { prereq=$1; shift; } || prereq=
358         test "$#" = 2 ||
359         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
360         if ! test_skip "$@"
361         then
362                 say >&3 "checking known breakage: $2"
363                 test_run_ "$2"
364                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
365                 then
366                         test_known_broken_ok_ "$1"
367                 else
368                         test_known_broken_failure_ "$1"
369                 fi
370         fi
371         echo >&3 ""
374 test_expect_success () {
375         test "$#" = 3 && { prereq=$1; shift; } || prereq=
376         test "$#" = 2 ||
377         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
378         if ! test_skip "$@"
379         then
380                 say >&3 "expecting success: $2"
381                 test_run_ "$2"
382                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
383                 then
384                         test_ok_ "$1"
385                 else
386                         test_failure_ "$@"
387                 fi
388         fi
389         echo >&3 ""
392 test_expect_code () {
393         test "$#" = 4 && { prereq=$1; shift; } || prereq=
394         test "$#" = 3 ||
395         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
396         if ! test_skip "$@"
397         then
398                 say >&3 "expecting exit code $1: $3"
399                 test_run_ "$3"
400                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
401                 then
402                         test_ok_ "$2"
403                 else
404                         test_failure_ "$@"
405                 fi
406         fi
407         echo >&3 ""
410 # test_external runs external test scripts that provide continuous
411 # test output about their progress, and succeeds/fails on
412 # zero/non-zero exit code.  It outputs the test output on stdout even
413 # in non-verbose mode, and announces the external script with "* run
414 # <n>: ..." before running it.  When providing relative paths, keep in
415 # mind that all scripts run in "trash directory".
416 # Usage: test_external description command arguments...
417 # Example: test_external 'Perl API' perl ../path/to/test.pl
418 test_external () {
419         test "$#" = 4 && { prereq=$1; shift; } || prereq=
420         test "$#" = 3 ||
421         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
422         descr="$1"
423         shift
424         if ! test_skip "$descr" "$@"
425         then
426                 # Announce the script to reduce confusion about the
427                 # test output that follows.
428                 say_color "" " run $test_count: $descr ($*)"
429                 # Run command; redirect its stderr to &4 as in
430                 # test_run_, but keep its stdout on our stdout even in
431                 # non-verbose mode.
432                 "$@" 2>&4
433                 if [ "$?" = 0 ]
434                 then
435                         test_ok_ "$descr"
436                 else
437                         test_failure_ "$descr" "$@"
438                 fi
439         fi
442 # Like test_external, but in addition tests that the command generated
443 # no output on stderr.
444 test_external_without_stderr () {
445         # The temporary file has no (and must have no) security
446         # implications.
447         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
448         stderr="$tmp/git-external-stderr.$$.tmp"
449         test_external "$@" 4> "$stderr"
450         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
451         descr="no stderr: $1"
452         shift
453         say >&3 "expecting no stderr from previous command"
454         if [ ! -s "$stderr" ]; then
455                 rm "$stderr"
456                 test_ok_ "$descr"
457         else
458                 if [ "$verbose" = t ]; then
459                         output=`echo; echo Stderr is:; cat "$stderr"`
460                 else
461                         output=
462                 fi
463                 # rm first in case test_failure exits.
464                 rm "$stderr"
465                 test_failure_ "$descr" "$@" "$output"
466         fi
469 # This is not among top-level (test_expect_success | test_expect_failure)
470 # but is a prefix that can be used in the test script, like:
472 #       test_expect_success 'complain and die' '
473 #           do something &&
474 #           do something else &&
475 #           test_must_fail git checkout ../outerspace
476 #       '
478 # Writing this as "! git checkout ../outerspace" is wrong, because
479 # the failure could be due to a segv.  We want a controlled failure.
481 test_must_fail () {
482         "$@"
483         test $? -gt 0 -a $? -le 129 -o $? -gt 192
486 # test_cmp is a helper function to compare actual and expected output.
487 # You can use it like:
489 #       test_expect_success 'foo works' '
490 #               echo expected >expected &&
491 #               foo >actual &&
492 #               test_cmp expected actual
493 #       '
495 # This could be written as either "cmp" or "diff -u", but:
496 # - cmp's output is not nearly as easy to read as diff -u
497 # - not all diff versions understand "-u"
499 test_cmp() {
500         $GIT_TEST_CMP "$@"
503 # Most tests can use the created repository, but some may need to create more.
504 # Usage: test_create_repo <directory>
505 test_create_repo () {
506         test "$#" = 1 ||
507         error "bug in the test script: not 1 parameter to test-create-repo"
508         owd=`pwd`
509         repo="$1"
510         mkdir -p "$repo"
511         cd "$repo" || error "Cannot setup test environment"
512         "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
513         error "cannot run git init -- have you built things yet?"
514         mv .git/hooks .git/hooks-disabled
515         cd "$owd"
518 test_done () {
519         GIT_EXIT_OK=t
520         test_results_dir="$TEST_DIRECTORY/test-results"
521         mkdir -p "$test_results_dir"
522         test_results_path="$test_results_dir/${0%.sh}-$$"
524         echo "total $test_count" >> $test_results_path
525         echo "success $test_success" >> $test_results_path
526         echo "fixed $test_fixed" >> $test_results_path
527         echo "broken $test_broken" >> $test_results_path
528         echo "failed $test_failure" >> $test_results_path
529         echo "" >> $test_results_path
531         if test "$test_fixed" != 0
532         then
533                 say_color pass "fixed $test_fixed known breakage(s)"
534         fi
535         if test "$test_broken" != 0
536         then
537                 say_color error "still have $test_broken known breakage(s)"
538                 msg="remaining $(($test_count-$test_broken)) test(s)"
539         else
540                 msg="$test_count test(s)"
541         fi
542         case "$test_failure" in
543         0)
544                 say_color pass "passed all $msg"
546                 test -d "$remove_trash" &&
547                 cd "$(dirname "$remove_trash")" &&
548                 rm -rf "$(basename "$remove_trash")"
550                 exit 0 ;;
552         *)
553                 say_color error "failed $test_failure among $msg"
554                 exit 1 ;;
556         esac
559 # Test the binaries we have just built.  The tests are kept in
560 # t/ subdirectory and are run in 'trash directory' subdirectory.
561 TEST_DIRECTORY=$(pwd)
562 if test -z "$valgrind"
563 then
564         if test -z "$GIT_TEST_INSTALLED"
565         then
566                 PATH=$TEST_DIRECTORY/..:$PATH
567                 GIT_EXEC_PATH=$TEST_DIRECTORY/..
568         else
569                 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
570                 error "Cannot run git from $GIT_TEST_INSTALLED."
571                 PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
572                 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
573         fi
574 else
575         make_symlink () {
576                 test -h "$2" &&
577                 test "$1" = "$(readlink "$2")" || {
578                         # be super paranoid
579                         if mkdir "$2".lock
580                         then
581                                 rm -f "$2" &&
582                                 ln -s "$1" "$2" &&
583                                 rm -r "$2".lock
584                         else
585                                 while test -d "$2".lock
586                                 do
587                                         say "Waiting for lock on $2."
588                                         sleep 1
589                                 done
590                         fi
591                 }
592         }
594         make_valgrind_symlink () {
595                 # handle only executables
596                 test -x "$1" || return
598                 base=$(basename "$1")
599                 symlink_target=$TEST_DIRECTORY/../$base
600                 # do not override scripts
601                 if test -x "$symlink_target" &&
602                     test ! -d "$symlink_target" &&
603                     test "#!" != "$(head -c 2 < "$symlink_target")"
604                 then
605                         symlink_target=../valgrind.sh
606                 fi
607                 case "$base" in
608                 *.sh|*.perl)
609                         symlink_target=../unprocessed-script
610                 esac
611                 # create the link, or replace it if it is out of date
612                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
613         }
615         # override all git executables in TEST_DIRECTORY/..
616         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
617         mkdir -p "$GIT_VALGRIND"/bin
618         for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
619         do
620                 make_valgrind_symlink $file
621         done
622         OLDIFS=$IFS
623         IFS=:
624         for path in $PATH
625         do
626                 ls "$path"/git-* 2> /dev/null |
627                 while read file
628                 do
629                         make_valgrind_symlink "$file"
630                 done
631         done
632         IFS=$OLDIFS
633         PATH=$GIT_VALGRIND/bin:$PATH
634         GIT_EXEC_PATH=$GIT_VALGRIND/bin
635         export GIT_VALGRIND
636 fi
637 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
638 unset GIT_CONFIG
639 GIT_CONFIG_NOSYSTEM=1
640 GIT_CONFIG_NOGLOBAL=1
641 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
643 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
644 export GITPERLLIB
645 test -d ../templates/blt || {
646         error "You haven't built things yet, have you?"
649 if ! test -x ../test-chmtime; then
650         echo >&2 'You need to build test-chmtime:'
651         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
652         exit 1
653 fi
655 . ../GIT-BUILD-OPTIONS
657 # Test repository
658 test="trash directory.$(basename "$0" .sh)"
659 test ! -z "$debug" || remove_trash="$TEST_DIRECTORY/$test"
660 rm -fr "$test" || {
661         GIT_EXIT_OK=t
662         echo >&5 "FATAL: Cannot prepare test area"
663         exit 1
666 test_create_repo "$test"
667 # Use -P to resolve symlinks in our working directory so that the cwd
668 # in subprocesses like git equals our $PWD (for pathname comparisons).
669 cd -P "$test" || exit 1
671 this_test=${0##*/}
672 this_test=${this_test%%-*}
673 for skp in $GIT_SKIP_TESTS
674 do
675         to_skip=
676         for skp in $GIT_SKIP_TESTS
677         do
678                 case "$this_test" in
679                 $skp)
680                         to_skip=t
681                 esac
682         done
683         case "$to_skip" in
684         t)
685                 say_color skip >&3 "skipping test $this_test altogether"
686                 say_color skip "skip all tests in $this_test"
687                 test_done
688         esac
689 done
691 # Fix some commands on Windows
692 case $(uname -s) in
693 *MINGW*)
694         # Windows has its own (incompatible) sort and find
695         sort () {
696                 /usr/bin/sort "$@"
697         }
698         find () {
699                 /usr/bin/find "$@"
700         }
701         sum () {
702                 md5sum "$@"
703         }
704         # git sees Windows-style pwd
705         pwd () {
706                 builtin pwd -W
707         }
708         # no POSIX permissions
709         # backslashes in pathspec are converted to '/'
710         # exec does not inherit the PID
711         ;;
712 *)
713         test_set_prereq POSIXPERM
714         test_set_prereq BSLASHPSPEC
715         test_set_prereq EXECKEEPSPID
716         ;;
717 esac
719 test -z "$NO_PERL" && test_set_prereq PERL
721 # test whether the filesystem supports symbolic links
722 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
723 rm -f y